// GraphWindow.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "MeshEditor.h"
#include "GraphWindow.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// GraphWindow

IMPLEMENT_DYNCREATE(GraphWindow, CFrameWnd)

GraphWindow::GraphWindow()
{
	value_N = 0;
	data_N = 0;
	data = NULL;
	value = NULL;
	sample = NULL;
	max = 1;
}

GraphWindow::~GraphWindow()
{
	if(data != NULL)
		delete data;
	if(value != NULL)
		delete value;
}


BEGIN_MESSAGE_MAP(GraphWindow, CFrameWnd)
	//{{AFX_MSG_MAP(GraphWindow)
	ON_WM_SIZE()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// GraphWindow bZ[W nh

void GraphWindow::drawGraph()
{
	if(data_N == 0)
		return;

	CRect rect;
	this->GetClientRect(&rect);
	CClientDC* dc = new CClientDC(this); 
	//CDC *dc;
	//PAINTSTRUCT pstruct;

	//if(dc = BeginPaint(&pstruct)){
		dc->FillRect(rect, NULL);

		dc->SetBkColor(RGB(255,255,255));
		dc->SetTextColor(RGB(0,0,0));

		CString s;
		s.Format("Clip Min: %f", min_v);
		dc->TextOut(0, 0, s);
		s.Format("Clip Max: %f", max_v);
		dc->TextOut(0, 20, s);
		s.Format("Average : %f", mid);
		dc->TextOut(0, 40, s);
		s.Format("Varience: %f", vari);
		dc->TextOut(0, 60, s);
		
		int x0 = 20;
		int y0 = rect.bottom - 20;
		int w = rect.Width()-30;
		int h = rect.Height()-30;
		
		float c[3];
		for(int i=0 ;i<value_N; i++){
			this->convertColor(sample[i], c);
			CPen pen(PS_SOLID, 1, RGB(255*c[0], 255*c[1], 255*c[2]));
			CPen *old_pen = dc->SelectObject(&pen);
			int x = i*w/value_N + x0;
			int y = -value[i]*h/max + y0;
			dc->MoveTo(x, y0);
			dc->LineTo(x,y);
			dc->SelectObject(old_pen);
			pen.DeleteObject();
		}
	//}

	//EndPaint(&pstruct);

	delete dc;
}

void GraphWindow::setData(double *data, int data_N)
{
	this->data = data;
	this->data_N = data_N;
	double S = 0;
	for(int i=0; i<data_N; i++)
		S += data[i];
	mid = S/(double)data_N;

	S = 0;
	for(i = 0; i<data_N; i++)
		S += (data[i]-mid)*(data[i]-mid);
	vari = sqrt(S/(double)data_N);

	max_v = 3.0*vari + mid;
	min_v = -3.0*vari + mid;

	computValue();

	Invalidate(TRUE);
	UpdateWindow();
}
/*
	for(i=0; i<value_N; i++)
		value[i] = 0;

	for(i = 0; i<data_N; i++){
		double s = 1.5*(data[i]-mid)/vari;
		int index;


		if(s < -2.1){
			int index = (int)(255*(s+2.7)/0.6);
			if(index < 0)
				index = 0;
			value[index]++;
		}
		else if(s < -1.5){
			value[(int)(255*(s+2.1)/0.6)+256]++;
		}
		else if(s < -0.9){
			value[(int)(255*(s+1.5)/0.6)+2*256]++;
		}
		else if(s < -0.3){
			value[(int)(255*(s+0.9)/0.6)+3*256]++;
		}
		else if(s < 0.3){
			value[(int)(255*(s+0.3)/0.6)+4*256]++;
		}
		else if(s < 0.9f){
			value[(int)(255*(s-0.3)/0.6)+5*256]++;
		}
		else if(s < 1.5f){
			value[(int)(255*(s-0.9)/0.6)+6*256]++;
		}
		else if(s < 2.1f){
			value[(int)(255*(s-1.5)/0.6)+7*256]++;
		}
		else{
			int index = (int)(255*(s-2.1)/0.6);
			if(index > 255)
				index = 255;
			value[index+8*256]++;
		}
	}
	max = 0;
	for(i=0; i<value_N; i++)
		if(max < value[i])
			max = value[i];
	this->drawGraph();
}
*/

void GraphWindow::OnSize(UINT nType, int cx, int cy) 
{
	CFrameWnd::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if(cx <= 0 || cy <= 0)
		return;

	value_N = cx - 30;

	this->computValue();
	this->drawGraph();
}

void GraphWindow::computValue()
{
	if(value != NULL)
		delete value;
	value = new int[value_N];

	if(sample != NULL)
		delete sample;
	sample = new double[value_N];

	for(int i=0; i<value_N; i++)
		value[i] = 0;

	double range = max_v - min_v;
	for(i=0; i<data_N; i++){
		int index = (int)(value_N*(data[i]-min_v)/range);
		if(index < 0)
			index = 0;
		else if(index >= value_N)
			index = value_N-1;

		value[index]++;
	}

	max = 0;
	for(i=0; i<value_N; i++)
		if(max < value[i])
			max = value[i];

	for(i=0; i<value_N; i++)
		sample[i] = range*i/value_N + min_v;
}

LRESULT GraphWindow::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	/*
	if(message != WM_SIZE)
		
	else if(message != WM_DESTROY)
		return NULL;
		*/
	return CFrameWnd::WindowProc(message, wParam, lParam);
}

void GraphWindow::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	drawGraph();
	// `pbZ[WƂ CFrameWnd::OnPaint() ĂяoĂ͂܂
}

void GraphWindow::convertColor(double v, float color[])
{
	float s = (float)((v-mid)/vari*1.5f);
	if(s < -2.1f){
		color[0] = 0;
		color[1] = 0;
		color[2] = 0;
	}
	else if(s < -1.5f){
		color[0] = 0;
		color[1] = 0;
		color[2] = (s + 2.1f)/0.6f;
	}
	else if(s < -0.9f){
		color[0] = 0;
		color[1] = (s + 1.5f)/0.6f;
		color[2] = 1;
	}
	else if(s < -0.3f){
		color[0] = 0;
		color[1] = 1;
		color[2] = -(s + 0.3f)/0.6f;
	}
	else if(s < 0.3f){
		color[0] = (s + 0.3f)/0.6f;
		color[1] = 1;
		color[2] = 0;
	}
	else if(s < 0.9f){
		color[0] = 1;
		color[1] = -(s - 0.9f)/0.6f;
		color[2] = 0;
	}
	else if(s < 1.5f){
		color[0] = 1;
		color[1] = 0;
		color[2] = (s - 0.9f)/0.6f;
	}
	else if(s < 2.1f){
		color[0] = 1;
		color[1] = (s - 1.5f)/0.8f;
		color[2] = 1;
	}
	else{
		color[0] = 1;
		color[1] = 0.75;
		color[2] = 1;
	}
}

BOOL GraphWindow::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	cs.cx = 300;
	cs.cy = 200;

	return CFrameWnd::PreCreateWindow(cs);
}
